/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 11/25/98                                                    */
/***************************************************************/

class Ambient
{

  //Instance variables
  protected double fIamb[] = new double[3];         //Ambient Intensity - I = IaKa 
  protected double fKa[] = new double[3];         //Coefficient of ambient reflection at intersection
  protected double fIa[] = new double[3];  //Intensity of ambient light at intersection

  //Constructors
  public Ambient ()
  {
    int i;

    for (i = 0; i < 3; i++)
    {
      fKa[i] = 0.0;
      fIa[i] = 1.0;
      fIamb[i] = 0.0;
    }
  } //Ambient

  public void setIntensity (double r, double g, double b)
  {
    fIa[0] = r;
    fIa[1] = g;
    fIa[2] = b;
  }

  public void setIntensity (double rgb[])
  {
    fIa[0] = rgb[0];
    fIa[1] = rgb[1];
    fIa[2] = rgb[2];
  }

  public void setCoefficient (double r, double g, double b)
  {
    fKa[0] = r;
    fKa[1] = g;
    fKa[2] = b;
  }

  public void setCoefficient (double rgb[])
  {
    fKa[0] = rgb[0];
    fKa[1] = rgb[1];
    fKa[2] = rgb[2];
  }

  public void computeIntensity ()
  {
    fIamb[0] = fKa[0] * fIa[0];
    fIamb[1] = fKa[1] * fIa[1];
    fIamb[2] = fKa[2] * fIa[2];
  }

  //Fills a given array with intensity.  Returns pointer to array for convenience.
  public double[] getIntensity (double out[])
  {
    out[0] = fIamb[0];
    out[1] = fIamb[1];
    out[2] = fIamb[2];

    return out;
  }

  public float getRed ()
  {
    return (float) fIamb[0];
  }

  public float getGreen ()
  {
    return (float)fIamb[1];
  }
  
  public float getBlue ()
  {
    return (float) fIamb[2];
  }
} //Ambient
