/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* Assignment 5                                                */
/* 11/25/98                                                    */
/***************************************************************/

import java.applet.*;
import java.awt.*;
import java.util.*;

public class Assignment5 extends Applet
{
  int fWidth;
  int fHeight;
  Vector fSpheres = new Vector ();

  //init
  public void init ()
  {
		String param;
    
    //Read width and height from tag
    param = getParameter("width");
		fWidth = (param == null) ? 300 : Integer.parseInt(param);
    param = getParameter("height");
		fHeight = (param == null) ? 300 : Integer.parseInt(param);
    param = getParameter("file");
		if (param == null)
      param = "spheres.dat";

    loadFile (param);
  }  //init

  public void loadFile (String file)
  {
    Sphere s;
    GWReader reader = new GWReader (file, this);
    int total = reader.getint ();
    int i;
    double store[] = new double[4];

    for (i = 0; i < total; i++)
    {
      store[0] = reader.getdouble ();
      store[1] = reader.getdouble ();
      store[2] = reader.getdouble ();
      store[3] = reader.getdouble ();
      s = new Sphere (new Vector3d (store[0], store[1], store[2]), store[3]);

      store[0] = reader.getdouble ();
      store[1] = reader.getdouble ();
      store[2] = reader.getdouble ();
      s.getAmbient ().setIntensity (store[0], store[1], store[2]);

      store[0] = reader.getdouble ();
      store[1] = reader.getdouble ();
      store[2] = reader.getdouble ();
      s.getAmbient ().setCoefficient (store[0], store[1], store[2]);

      store[0] = reader.getdouble ();
      store[1] = reader.getdouble ();
      store[2] = reader.getdouble ();
      s.getDiffuse ().setIntensity (store[0], store[1], store[2]);

      store[0] = reader.getdouble ();
      store[1] = reader.getdouble ();
      store[2] = reader.getdouble ();
      s.getDiffuse ().setCoefficient (store[0], store[1], store[2]);

      store[0] = reader.getdouble ();
      store[1] = reader.getdouble ();
      store[2] = reader.getdouble ();
      s.getDiffuse ().setLightPosition (new Vector3d (store[0], store[1], store[2]));

      fSpheres.addElement (s);
    }
  }

  public void paint (Graphics g)
  {
    int i;
    double x, 
           y, 
           nearpoint, 
           result,
           xinc = 2.0/(double)fWidth, 
           yinc = 2.0/(double)fHeight;
    Sphere nearest = null;

    //Create a ray with initial position and direction
    Ray ray = new Ray (new Vector3d (0.0, 0.0, 0.0), new Vector3d (-1.0, -1.0, 1.0));

    //Clear background to black
    g.setColor (Color.black);
    g.fillRect (0, 0, fWidth, fHeight);
    
    for (x = -1.0; x <= 1.0; x += xinc)
    {
      for (y = -1.0; y <= 1.0; y += yinc)
      {
        ray.setDirection (x, y, 1.0);

        //compute for all spheres
        nearpoint = -1.0;
        for (i = 0; i < fSpheres.size (); i++)
        {
          result = ((Sphere) fSpheres.elementAt (i)).nearestIntersection (ray);

          if ((result > 0) && (nearpoint == -1 || result < nearpoint))
          {
            nearpoint = result;
            nearest = (Sphere) fSpheres.elementAt (i);
          }
        }

        if (nearpoint != -1)
        {
          nearest.computeColor ();
          g.setColor (new Color (nearest.getRed (), nearest.getGreen (), nearest.getBlue ()));

          g.drawLine (xToScreen ((x + 1.0) / 2.0), yToScreen ((y + 1.0) / 2.0), 
                      xToScreen ((x + 1.0) / 2.0), yToScreen ((y + 1.0) / 2.0));
        }
      }
    }

    System.out.print ("Done\n");

  }  //paint

  //Method to do Cartesian to pixel conversions for X axis
  protected int xToScreen (double x)
  {
    return (int) Math.round (x * ((double) fWidth));
  } //xToScreen

  //Method to do Cartesian to pixel conversions for Y axis
  //without directional adjustment
  protected int yToScreenRaw (double y)
  {
    return (int) Math.round (y * ((double) fHeight));
  } //yToScreenRaw

  //Method to do Cartesian to pixel conversions for Y axis
  protected int yToScreen (double y)
  {
    return (fHeight - yToScreenRaw (y));
  } //yToScreen

}
