/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 11/25/98                                                    */
/***************************************************************/

class Vector3d
{

  //Instance variables
  public double fX;
  public double fY;
  public double fZ;

  //Constructors
  public Vector3d ()
  {
    fX = 0.0;
    fY = 0.0;
    fZ = 0.0;
  } //Vector3d

  public Vector3d (double xin, double yin, double zin)
  {
    fX = xin;
    fY = yin;
    fZ = zin;
  } //Vector3d

  public double magnitude ()
  {
    return Math.sqrt ((fX * fX) + (fY * fY) + (fZ * fZ));
  }

  public double dotProduct (Vector3d in)
  {
    return (fX * in.fX) + (fY * in.fY) + (fZ * in.fZ);
  }

  public Vector3d crossProduct (Vector3d in)
  {
    Vector3d result = new Vector3d ();

    result.fX = (fY * in.fZ) - (fZ * in.fY);
    result.fY = (fZ * in.fX) - (fX * in.fZ);
    result.fZ = (fX * in.fY) - (fY * in.fX);

    return result;    
  }

  public Vector3d normalize ()
  {
    double scalar;
    Vector3d result = new Vector3d ();

    scalar = magnitude ();
    result.fX = fX/scalar;
    result.fY = fY/scalar;
    result.fZ = fZ/scalar;

    return result;    
  }


} //Vector3d
